/*! @mainpage Core Plot
 *
 * @section intro Introduction
 *
 * Core Plot is a plotting framework for Mac OS X and iPhone OS. It provides 2D visualization of data,
 * and is tightly integrated with Apple technologies like Core Animation, Core Data, and Cocoa Bindings.
 *
 * @section start Getting Started
 *
 * See the project wiki at
 * http://code.google.com/p/core-plot/wiki/UsingCorePlotInApplications for information on how to use Core Plot
 * in your own application.
 *
 * @section contribute Contributing to Core Plot 
 *
 * Core Plot is an open source project. The project home page is http://code.google.com/p/core-plot/ on Google Code.
 * See http://code.google.com/p/core-plot/source/checkout for instructions on how to download the source code.
 *
 * @subsection coding Coding Standards
 * Everyone has a their own preferred coding style, and no one way can be considered right. Nonetheless, in a
 * project like Core Plot, with many developers contributing, it is worthwhile defining a set of basic coding
 * standards to prevent a mishmash of different styles which can become frustrating when
 * navigating the code base. See the file <code>"Coding Style.mdown"</code> found in the <code>documentation</code> directory
 * of the project source for specific guidelines.
 *
 * @subsection documentation Documentation Policy
 * See http://code.google.com/p/core-plot/wiki/DocumentationPolicy for instructions on how to
 * document your code so that your comments will appear in these documentation pages.
 *
 * @subsection testing Testing Policy
 * Because Core Plot is intended to be used in scientific, financial, and other domains where correctness is paramount,
 * unit testing is integrated into the framework. Good test coverage protects developers from introducing accidental
 * regressions and frees them to experiment and refactor without fear of breaking things. See
 * http://code.google.com/p/core-plot/wiki/CorePlotTesting for instructions on how to build unit tests
 * for any new code you add to the project.
 */
